main()
{
	//maps\mp\mp_mine_fx::main();
	//maps\createart\mp_mine_art::main();
	maps\mp\_load::main();		
	maps\mp\_compass::setupMiniMap("compass_map_mp_mine");

	//setExpFog(500, 2200, 0.81, 0.75, 0.63, 0);
	//VisionSetNaked( "mp_mine" );
	ambientPlay("ambient_mine_ext");

	game["allies"] = "sas";
	game["axis"] = "opfor";
	game["attackers"] = "axis";
	game["defenders"] = "allies";
	game["allies_soldiertype"] = "woodland";
	game["axis_soldiertype"] = "woodland";

	setdvar("r_specularcolorscale", "1" );
	setdvar("r_glowbloomintensity0",".25");
	setdvar("r_glowbloomintensity1",".25");
	setdvar("r_glowskybleedintensity0",".3");
	setdvar("compassmaxrange","1800");

	//fx
	level._effect["fire"] = loadfx ("fire/flame_small_em");

	//torch code
	torch = getentarray("torch","targetname");
	for(i=0;i<torch.size;i++)
	torch[i] thread torchfire();

	//grenadebutton code
	trig_grenade = getentarray("trig_grenade","targetname");
	for(i=0;i<trig_grenade.size;i++)
	{
		trig_grenade[i].grenadebuttonmodel = getent(trig_grenade[i].target, "targetname");
		trig_grenade[i].grenadebuttonmodel.grenadebuttonmoving = false;
		trig_grenade[i].grenadebuttonmodel.grenadebuttonup = true;
		trig_grenade[i].grenadebuttonmodel.time = 0.1; //how long it takes the grenadebutton to move
		trig_grenade[i] thread grenadebuttonmove();
	}

	//waterfall code
	waterfall = getentarray("waterfall","targetname");
	for(i=0;i<waterfall.size;i++)
	{
		waterfall[i].frame[0] = waterfall[i];
		waterfall[i].framemax = 8;
		for(j=1; j<waterfall[i].framemax; j++)
		{
			waterfall[i].frame[j] = getent(waterfall[i].frame[j-1].target, "targetname");
		}
		for(j=0; j<waterfall[i].framemax; j++)
		{
			waterfall[i].frame[j] notSolid();
			waterfall[i].frame[j] hide();
		}

		waterfall[i] thread waterfall_animation();
		waterfall[i] thread waterfall_sound();
	}

	//crate code
	trig_crate = getentarray("trig_crate","targetname");
	for(i=0;i<trig_crate.size;i++)
	{
		trig_crate[i].broken = 0;
		trig_crate[i].maxbroken = 3;
		trig_crate[i] thread crate_break();
	}

	//cart code
	trig_cart = getentarray("trig_cart","targetname");
	for(i=0;i<trig_cart.size;i++)
	{
		trig_cart[i].cart = getent(trig_cart[i].target, "targetname");
		trig_cart[i].trig_hurt = getent(trig_cart[i].cart.target, "targetname");
		trig_cart[i].trig_hurt EnableLinkTo();
		trig_cart[i].trig_hurt linkto (trig_cart[i].cart);
		trig_cart[i] EnableLinkTo();
		trig_cart[i] linkto (trig_cart[i].cart);
		trig_cart[i].track[0] = getent(trig_cart[i].trig_hurt.target, "targetname");
		trig_cart[i].exit_array_loop = false;
		j = 1;
		while (!trig_cart[i].exit_array_loop)
		{
			trig_cart[i].track[j] = getent(trig_cart[i].track[j-1].target, "targetname");
			if (trig_cart[i].track[j].script_noteworthy == "last")
			{
				trig_cart[i].track_max = j;
				trig_cart[i].track[j + 1] = getent(trig_cart[i].track[j].target, "targetname");				
				trig_cart[i].exit_array_loop = true;
			}
			j++;
		}
		trig_cart[i].rider = false;
		trig_cart[i].ridername = "world";		
		trig_cart[i].track_from = 0;
		trig_cart[i].track_to = 1;
		trig_cart[i].velocity = 400;
		trig_cart[i].time_interval = 0.5;
		trig_cart[i].cart_counter = 0;
		trig_cart[i] thread cart_inside();
		trig_cart[i] thread cart_hurt();
		trig_cart[i] thread cart_move();
	}
}

//cart_move code
cart_move()
{
	while(1)
	{
		while(self.rider)
		{
			if (self.ridername getstance() == "crouch")
			{
				self.cart_counter++;
				self.distance_to_from = Distance(self.track[self.track_to].origin, self.track[self.track_from].origin);
				self.distance_interval = self.velocity * self.time_interval;
				self.distance_count = 0;
				while(self.distance_count * self.distance_interval < self.distance_to_from)
				{
					self.distance_count++;
				}
				self.distance_count--;
				self.distance_remainder = self.distance_to_from - (self.distance_count * self.distance_interval);
				self.vector_interval = self.distance_interval * (self.track[self.track_to].origin - self.track[self.track_from].origin) / self.distance_to_from;
				self.vector_remainder = self.distance_remainder * (self.track[self.track_to].origin - self.track[self.track_from].origin) / self.distance_to_from;
				if (self.cart_counter <= self.distance_count)
				{
					self.cart moveto(self.track[self.track_from].origin + self.cart_counter * self.vector_interval, self.time_interval);
					self.cart playsound("train");
					self.cart waittill("movedone");
				}
				if (self.cart_counter > self.distance_count)
				{
					if ((self.track[self.track_from].script_noteworthy == "right1") || (self.track[self.track_from].script_noteworthy == "right2") || (self.track[self.track_from].script_noteworthy == "right3"))
					{
						self.cart RotateYaw(-30, self.distance_remainder / self.velocity);
					}
					else if ((self.track[self.track_from].script_noteworthy == "left1") || (self.track[self.track_from].script_noteworthy == "left2") || (self.track[self.track_from].script_noteworthy == "left3"))
					{
						self.cart RotateYaw(30, self.distance_remainder / self.velocity);
					}
					self.cart moveto(self.track[self.track_to].origin, self.distance_remainder / self.velocity);
					self.cart playsound("train");
					self.cart waittill("movedone");
					self.track_from++;
					self.track_to++;
					if (self.track_to > self.track_max)
					{
						self.track_from = 0;
						self.track_to = 1;
					}
					self.cart_counter = 0;
				}
			}
			else
			{
				wait(0.01);	
			}
		}
		wait(0.01);
	}
}

//cart_hurt code
cart_hurt()
{
	while (1)
	{
		self.trig_hurt waittill("trigger", user);
		if (self.rider)
		{
			RadiusDamage(user.origin, 1, 1000, 1000, self.ridername);
		}
		wait(0.01);	
	}
}

//cart_inside code
cart_inside()
{
	while (1)
	{
		self waittill("trigger", user);
		user.cart_inside_exit_count = 0;	
		if (!isdefined(user.cart_in))
		{
			user.cart_in = false;
		}
		if (!user.cart_in)
		{
			user.cart_in = true;
			self thread cart_inside_exit_count_loop(user);
			self thread cart_inside_enter(user);
		}
	}
}

cart_inside_enter(user)
{
	self.rider = true;
	self.ridername = user;
}

cart_inside_exit(user)
{
	self.rider = false;
	self.ridername = "world";
}

cart_inside_exit_count_loop(user)
{
	while (user.cart_inside_exit_count < 3)
	{
		user.cart_inside_exit_count++;
		wait(0.1);
	}
	user.cart_in = false;
	self thread cart_inside_exit(user);
}

//crate code
crate_break()
{
	while (1)
	{
		self waittill("trigger", user);
		self.crate = getent(self.target, "targetname");
		if(self.broken < self.maxbroken)
		{
			self.broken = self.broken + 1;
			if(self.broken == self.maxbroken)
			{
				self playsound("break");
				self.crate notsolid();
				self.crate hide();
			}
			wait(0.1);
		}
	}
}

//waterfall code
waterfall_animation()
{
	animation_time = 0.01;
	while (true)
	{	
		for(j=1; j<self.framemax; j++)
		{
			self.frame[j] show();
			wait(animation_time);
			self.frame[j] hide();
		}
	}
}

waterfall_sound()
{
	while (true)
	{	
		self playsound("waterfall");
		wait(1.5);
	}
}

//grenadebutton code
grenadebuttonmove()
{
	while (1)
	{
		self waittill("trigger", user);
		if(!self.grenadebuttonmodel.grenadebuttonmoving)
		{
			self.grenadebuttonmodel.grenadebuttonmoving = true;
			if (user GetWeaponAmmoClip("frag_grenade_mp") < 4)
			{
				self playsound("givegrenade");
				user givemaxammo("frag_grenade_mp");
				wait(0.01);
			}
			self.grenadebuttonmodel movez(-1,self.grenadebuttonmodel.time);
			self.grenadebuttonmodel waittill("movedone");
			self.grenadebuttonmodel movez(1,self.grenadebuttonmodel.time);
			self.grenadebuttonmodel waittill("movedone");
			self.grenadebuttonmodel.grenadebuttonmoving = false;			
		}
	}
}

torchfire()
{
	maps\mp\_fx::loopfx("fire", (self.origin + (0, 0, 16)), 0.5);	
}